Index: trunk/modules/vci_mem_cache_v4/caba/source/include/vci_mem_cache_v4.h
===================================================================
--- trunk/modules/vci_mem_cache_v4/caba/source/include/vci_mem_cache_v4.h	(revision 253)
+++ trunk/modules/vci_mem_cache_v4/caba/source/include/vci_mem_cache_v4.h	(revision 273)
@@ -26,6 +26,5 @@
  *
  * Maintainers: alain eric.guthmuller@polytechnique.edu
- */
-/*
+ *              cesar.fuguet-tortolero@lip6.fr
  *
  * Modifications done by Christophe Choichillon on the 7/04/2009:
@@ -33,5 +32,5 @@
  * - Adding a new VCI target port for the CLEANUP network
  * - Adding new state in the ALLOC_UPT_FSM : ALLOC_UPT_CLEANUP
- * 
+ *
  * Modifications to do :
  * - Adding new variables used by the CLEANUP FSM
@@ -58,6 +57,6 @@
 #include "update_tab_v4.h"
 
-#define TRANSACTION_TAB_LINES 	4     		// Number of lines in the transaction tab
-#define UPDATE_TAB_LINES 	4          	// Number of lines in the update tab
+#define TRANSACTION_TAB_LINES 4 // Number of lines in the transaction tab
+#define UPDATE_TAB_LINES      4 // Number of lines in the update tab
 
 namespace soclib {  namespace caba {
@@ -81,5 +80,5 @@
         TGT_CMD_READ,
         TGT_CMD_WRITE,
-        TGT_CMD_ATOMIC,
+        TGT_CMD_ATOMIC
       };
 
@@ -97,5 +96,5 @@
         TGT_RSP_XRAM,
         TGT_RSP_INIT,
-        TGT_RSP_CLEANUP,
+        TGT_RSP_CLEANUP
       };
 
@@ -115,5 +114,5 @@
         INIT_CMD_SC_UPDT_INDEX,
         INIT_CMD_SC_UPDT_DATA,
-        INIT_CMD_SC_UPDT_DATA_HIGH,
+        INIT_CMD_SC_UPDT_DATA_HIGH
       };
 
@@ -123,5 +122,5 @@
         INIT_RSP_UPT_LOCK,
         INIT_RSP_UPT_CLEAR,
-        INIT_RSP_END,
+        INIT_RSP_END
       };
 
@@ -129,6 +128,8 @@
       enum read_fsm_state_e{
         READ_IDLE,
+        READ_DIR_REQ,
         READ_DIR_LOCK,
         READ_DIR_HIT,
+        READ_HEAP_REQ,
         READ_HEAP_LOCK,
         READ_HEAP_WRITE,
@@ -138,5 +139,5 @@
         READ_TRT_LOCK,
         READ_TRT_SET,
-        READ_TRT_REQ,
+        READ_TRT_REQ
       };
 
@@ -145,4 +146,5 @@
         WRITE_IDLE,
         WRITE_NEXT,
+        WRITE_DIR_REQ,
         WRITE_DIR_LOCK,
         WRITE_DIR_READ,
@@ -163,5 +165,5 @@
         WRITE_BC_CC_SEND,
         WRITE_BC_XRAM_REQ,
-        WRITE_WAIT,
+        WRITE_WAIT
       };
 
@@ -171,5 +173,5 @@
         IXR_RSP_ACK,
         IXR_RSP_TRT_ERASE,
-        IXR_RSP_TRT_READ,
+        IXR_RSP_TRT_READ
       };
 
@@ -186,8 +188,9 @@
         XRAM_RSP_INVAL,
         XRAM_RSP_WRITE_DIRTY,
+        XRAM_RSP_HEAP_REQ,
         XRAM_RSP_HEAP_ERASE,
         XRAM_RSP_HEAP_LAST,
         XRAM_RSP_ERROR_ERASE,
-        XRAM_RSP_ERROR_RSP,
+        XRAM_RSP_ERROR_RSP
       };
 
@@ -201,5 +204,5 @@
         IXR_CMD_WRITE_NLINE,
         IXR_CMD_SC_NLINE,
-        IXR_CMD_XRAM_DATA,
+        IXR_CMD_XRAM_DATA
       };
 
@@ -207,4 +210,5 @@
       enum sc_fsm_state_e{
         SC_IDLE,
+        SC_DIR_REQ,
         SC_DIR_LOCK,
         SC_DIR_HIT_READ,
@@ -224,5 +228,5 @@
         SC_MISS_TRT_SET,
         SC_MISS_XRAM_REQ,
-        SC_WAIT,
+        SC_WAIT
       };
 
@@ -230,6 +234,8 @@
       enum cleanup_fsm_state_e{
         CLEANUP_IDLE,
+        CLEANUP_DIR_REQ,
         CLEANUP_DIR_LOCK,
         CLEANUP_DIR_WRITE,
+        CLEANUP_HEAP_REQ,
         CLEANUP_HEAP_LOCK,
         CLEANUP_HEAP_SEARCH,
@@ -239,14 +245,15 @@
         CLEANUP_UPT_WRITE,
         CLEANUP_WRITE_RSP,
-        CLEANUP_RSP,
+        CLEANUP_RSP
       };
 
       /* States of the ALLOC_DIR fsm */
       enum alloc_dir_fsm_state_e{
+        ALLOC_DIR_RESET,
         ALLOC_DIR_READ,
         ALLOC_DIR_WRITE,
         ALLOC_DIR_SC,
         ALLOC_DIR_CLEANUP,
-        ALLOC_DIR_XRAM_RSP,
+        ALLOC_DIR_XRAM_RSP
       };
 
@@ -257,5 +264,5 @@
         ALLOC_TRT_SC,
         ALLOC_TRT_XRAM_RSP,
-        ALLOC_TRT_IXR_RSP,
+        ALLOC_TRT_IXR_RSP
       };
 
@@ -266,14 +273,15 @@
         ALLOC_UPT_INIT_RSP,
         ALLOC_UPT_CLEANUP,
-        ALLOC_UPT_SC,
+        ALLOC_UPT_SC
       };
 
       /* States of the ALLOC_HEAP fsm */
       enum alloc_heap_fsm_state_e{
+        ALLOC_HEAP_RESET,
         ALLOC_HEAP_READ,
         ALLOC_HEAP_WRITE,
         ALLOC_HEAP_SC,
         ALLOC_HEAP_CLEANUP,
-        ALLOC_HEAP_XRAM_RSP,
+        ALLOC_HEAP_XRAM_RSP
       };
 
@@ -301,21 +309,21 @@
 
       // instrumentation counters
-      uint32_t	   m_cpt_cycles;            // Counter of cycles 
-      uint32_t	   m_cpt_read;              // Number of READ transactions
-      uint32_t	   m_cpt_read_miss;         // Number of MISS READ 
-      uint32_t	   m_cpt_write;             // Number of WRITE transactions
-      uint32_t	   m_cpt_write_miss;        // Number of MISS WRITE
-      uint32_t     m_cpt_write_cells;	    // Cumulated length for WRITE transactions
-      uint32_t     m_cpt_write_dirty;	    // Cumulated length for WRITE transactions
-      uint32_t	   m_cpt_update;            // Number of UPDATE transactions
-      uint32_t     m_cpt_trt_rb;            // Read blocked by a hit in trt
-      uint32_t     m_cpt_trt_full;          // Transaction blocked due to a full trt
-      uint32_t	   m_cpt_update_mult;       // Number of targets for UPDATE
-      uint32_t	   m_cpt_inval;             // Number of INVAL  transactions
-      uint32_t	   m_cpt_inval_mult;        // Number of targets for INVAL  
-      uint32_t	   m_cpt_inval_brdcast;     // Number of BROADCAST INVAL  
-      uint32_t	   m_cpt_cleanup;           // Number of CLEANUP transactions
-      uint32_t	   m_cpt_ll;                // Number of LL transactions
-      uint32_t	   m_cpt_sc;                // Number of SC transactions
+      uint32_t     m_cpt_cycles;        // Counter of cycles
+      uint32_t     m_cpt_read;          // Number of READ transactions
+      uint32_t     m_cpt_read_miss;     // Number of MISS READ
+      uint32_t     m_cpt_write;         // Number of WRITE transactions
+      uint32_t     m_cpt_write_miss;    // Number of MISS WRITE
+      uint32_t     m_cpt_write_cells;   // Cumulated length for WRITE transactions
+      uint32_t     m_cpt_write_dirty;   // Cumulated length for WRITE transactions
+      uint32_t     m_cpt_update;        // Number of UPDATE transactions
+      uint32_t     m_cpt_trt_rb;        // Read blocked by a hit in trt
+      uint32_t     m_cpt_trt_full;      // Transaction blocked due to a full trt
+      uint32_t     m_cpt_update_mult;   // Number of targets for UPDATE
+      uint32_t     m_cpt_inval;         // Number of INVAL  transactions
+      uint32_t     m_cpt_inval_mult;    // Number of targets for INVAL
+      uint32_t     m_cpt_inval_brdcast; // Number of BROADCAST INVAL
+      uint32_t     m_cpt_cleanup;       // Number of CLEANUP transactions
+      uint32_t     m_cpt_ll;            // Number of LL transactions
+      uint32_t     m_cpt_sc;            // Number of SC transactions
 
       size_t       m_prev_count;
@@ -326,13 +334,13 @@
 
       public:
-      sc_in<bool> 			  	                p_clk;
-      sc_in<bool> 			  	                p_resetn;
-      soclib::caba::VciTarget<vci_param>    	p_vci_tgt;
-      soclib::caba::VciTarget<vci_param>    	p_vci_tgt_cleanup;
-      soclib::caba::VciInitiator<vci_param> 	p_vci_ini;	
-      soclib::caba::VciInitiator<vci_param> 	p_vci_ixr;
+      sc_in<bool>                           p_clk;
+      sc_in<bool>                           p_resetn;
+      soclib::caba::VciTarget<vci_param>    p_vci_tgt;
+      soclib::caba::VciTarget<vci_param>    p_vci_tgt_cleanup;
+      soclib::caba::VciInitiator<vci_param> p_vci_ini;
+      soclib::caba::VciInitiator<vci_param> p_vci_ixr;
 
       VciMemCacheV4(
-          sc_module_name name,                                // Instance Name 
+          sc_module_name name,                                // Instance Name
           const soclib::common::MappingTable &mtp,            // Mapping table for primary requets
           const soclib::common::MappingTable &mtc,            // Mapping table for coherence requets
@@ -342,5 +350,5 @@
           const soclib::common::IntTab &vci_tgt_index,        // VCI port to PROC (target)
           const soclib::common::IntTab &vci_tgt_index_cleanup,// VCI port to PROC (target) for cleanup
-          size_t nways,                                       // Number of ways per set 
+          size_t nways,                                       // Number of ways per set
           size_t nsets,                                       // Number of sets
           size_t nwords,                                      // Number of words per line
@@ -348,5 +356,5 @@
           size_t transaction_tab_lines=TRANSACTION_TAB_LINES, // Size of the TRT
           size_t update_tab_lines=UPDATE_TAB_LINES,           // Size of the UPT
-          size_t debug_start_cycle=0,                       
+          size_t debug_start_cycle=0,
           bool   debug_ok=false);
 
@@ -366,37 +374,38 @@
 
       // Component attributes
-      const size_t              		m_initiators;           // Number of initiators
-      const size_t              		m_heap_size;            // Size of the heap
-      const size_t              		m_ways;                 // Number of ways in a set
-      const size_t              		m_sets;                 // Number of cache sets
-      const size_t              		m_words;		        // Number of words in a line
-      const size_t              		m_srcid_ixr;		    // Srcid for requests to XRAM 
-      const size_t              		m_srcid_ini;		    // Srcid for requests to processors
-      std::list<soclib::common::Segment>  	m_seglist;    		// memory cached into the cache
-      std::list<soclib::common::Segment>  	m_cseglist;   		// coherence segment for the cache
-      vci_addr_t        		     	*m_coherence_table; 	// address(srcid)
-      uint32_t                    		m_transaction_tab_lines;
-      TransactionTab      		    	m_transaction_tab;	    // xram transaction table
-      uint32_t                    		m_update_tab_lines;
-      UpdateTab                 		m_update_tab;		    // pending update & invalidate 
-      CacheDirectory			        m_cache_directory;	    // data cache directory
-      HeapDirectory             		m_heap;                 // heap for copies
-
-      data_t	        	       		***m_cache_data;	    // data array[set][way][word]
+      std::list<soclib::common::Segment> m_seglist;  // memory cached into the cache
+      std::list<soclib::common::Segment> m_cseglist; // coherence segment for the cache
+
+      const size_t    m_initiators; // Number of initiators
+      const size_t    m_heap_size;  // Size of the heap
+      const size_t    m_ways;       // Number of ways in a set
+      const size_t    m_sets;       // Number of cache sets
+      const size_t    m_words;      // Number of words in a line
+      const size_t    m_srcid_ixr;  // Srcid for requests to XRAM
+      const size_t    m_srcid_ini;  // Srcid for requests to processors
+
+      uint32_t        m_transaction_tab_lines;
+      TransactionTab  m_transaction_tab;  // xram transaction table
+      uint32_t        m_update_tab_lines;
+      UpdateTab       m_update_tab;       // pending update & invalidate
+      CacheDirectory  m_cache_directory;  // data cache directory
+      HeapDirectory   m_heap;             // heap for copies
+
+      data_t      *** m_cache_data;       // data array[set][way][word]
 
       // adress masks
-      const soclib::common::AddressMaskingTable<vci_addr_t>   m_x;
-      const soclib::common::AddressMaskingTable<vci_addr_t>   m_y;
-      const soclib::common::AddressMaskingTable<vci_addr_t>   m_z;
-      const soclib::common::AddressMaskingTable<vci_addr_t>   m_nline; 
+      const soclib::common::AddressMaskingTable<vci_addr_t> m_x;
+      const soclib::common::AddressMaskingTable<vci_addr_t> m_y;
+      const soclib::common::AddressMaskingTable<vci_addr_t> m_z;
+      const soclib::common::AddressMaskingTable<vci_addr_t> m_nline;
 
       // broadcast address
-      vci_addr_t 			m_broadcast_address;
+      vci_addr_t m_broadcast_address;
 
       //////////////////////////////////////////////////
       // Others registers
       //////////////////////////////////////////////////
-      sc_signal<size_t>   r_copies_limit; // Limit of the number of copies for one line
-      sc_signal<size_t>   xxx_count;
+      sc_signal<size_t> r_copies_limit; // Limit of the number of copies for one line
+      sc_signal<size_t> xxx_count;
 
       //////////////////////////////////////////////////
@@ -411,5 +420,5 @@
       GenericFifo<size_t>    m_cmd_read_pktid_fifo;
 
-      // Fifo between TGT_CMD fsm and WRITE fsm    
+      // Fifo between TGT_CMD fsm and WRITE fsm
       GenericFifo<uint64_t>  m_cmd_write_addr_fifo;
       GenericFifo<bool>      m_cmd_write_eop_fifo;
@@ -418,5 +427,5 @@
       GenericFifo<size_t>    m_cmd_write_pktid_fifo;
       GenericFifo<data_t>    m_cmd_write_data_fifo;
-      GenericFifo<be_t>	     m_cmd_write_be_fifo;
+      GenericFifo<be_t>      m_cmd_write_be_fifo;
 
       // Fifo between TGT_CMD fsm and SC fsm
@@ -434,38 +443,37 @@
       soclib::common::Segment  **m_seg;
       soclib::common::Segment  **m_cseg;
-
       ///////////////////////////////////////////////////////
       // Registers controlled by the READ fsm
       ///////////////////////////////////////////////////////
 
-      sc_signal<int>         r_read_fsm;        // FSM state 
-      sc_signal<size_t>      r_read_copy;       // Srcid of the first copy
-      sc_signal<size_t>      r_read_copy_cache; // Srcid of the first copy
-      sc_signal<bool>        r_read_copy_inst;  // Type of the first copy
-      sc_signal<tag_t>       r_read_tag;	    // cache line tag (in directory)
-      sc_signal<bool>        r_read_is_cnt;	    // is_cnt bit (in directory)
-      sc_signal<bool>        r_read_lock;	    // lock bit (in directory)
-      sc_signal<bool>        r_read_dirty;	    // dirty bit (in directory)
-      sc_signal<size_t>      r_read_count;      // number of copies
-      sc_signal<size_t>      r_read_ptr;        // pointer to the heap
-      sc_signal<data_t>     *r_read_data;       // data (one cache line)
-      sc_signal<size_t>      r_read_way;        // associative way (in cache)
-      sc_signal<size_t>      r_read_trt_index;  // Transaction Table index
-      sc_signal<size_t>      r_read_next_ptr;   // Next entry to point to
-      sc_signal<bool>        r_read_last_free;  // Last free entry
-
-      // Buffer between READ fsm and IXR_CMD fsm (ask a missing cache line to XRAM)   
-      sc_signal<bool>        r_read_to_ixr_cmd_req;     // valid request
-      sc_signal<addr_t>      r_read_to_ixr_cmd_nline;   // cache line index
-      sc_signal<size_t>      r_read_to_ixr_cmd_trdid;   // index in Transaction Table
+      sc_signal<int>      r_read_fsm;        // FSM state
+      sc_signal<size_t>   r_read_copy;       // Srcid of the first copy
+      sc_signal<size_t>   r_read_copy_cache; // Srcid of the first copy
+      sc_signal<bool>     r_read_copy_inst;  // Type of the first copy
+      sc_signal<tag_t>    r_read_tag;        // cache line tag (in directory)
+      sc_signal<bool>     r_read_is_cnt;     // is_cnt bit (in directory)
+      sc_signal<bool>     r_read_lock;       // lock bit (in directory)
+      sc_signal<bool>     r_read_dirty;      // dirty bit (in directory)
+      sc_signal<size_t>   r_read_count;      // number of copies
+      sc_signal<size_t>   r_read_ptr;        // pointer to the heap
+      sc_signal<data_t> * r_read_data;       // data (one cache line)
+      sc_signal<size_t>   r_read_way;        // associative way (in cache)
+      sc_signal<size_t>   r_read_trt_index;  // Transaction Table index
+      sc_signal<size_t>   r_read_next_ptr;   // Next entry to point to
+      sc_signal<bool>     r_read_last_free;  // Last free entry
+
+      // Buffer between READ fsm and IXR_CMD fsm (ask a missing cache line to XRAM)
+      sc_signal<bool>     r_read_to_ixr_cmd_req;    // valid request
+      sc_signal<addr_t>   r_read_to_ixr_cmd_nline;  // cache line index
+      sc_signal<size_t>   r_read_to_ixr_cmd_trdid;  // index in Transaction Table
 
       // Buffer between READ fsm and TGT_RSP fsm (send a hit read response to L1 cache)
-      sc_signal<bool>	   r_read_to_tgt_rsp_req;       // valid request
-      sc_signal<size_t>	   r_read_to_tgt_rsp_srcid;	    // Transaction srcid
-      sc_signal<size_t>	   r_read_to_tgt_rsp_trdid;	    // Transaction trdid
-      sc_signal<size_t>	   r_read_to_tgt_rsp_pktid;	    // Transaction pktid
-      sc_signal<data_t>   *r_read_to_tgt_rsp_data;	    // data (one cache line)
-      sc_signal<size_t>    r_read_to_tgt_rsp_word;      // first word of the response
-      sc_signal<size_t>    r_read_to_tgt_rsp_length;    // length of the response
+      sc_signal<bool>     r_read_to_tgt_rsp_req;    // valid request
+      sc_signal<size_t>   r_read_to_tgt_rsp_srcid;  // Transaction srcid
+      sc_signal<size_t>   r_read_to_tgt_rsp_trdid;  // Transaction trdid
+      sc_signal<size_t>   r_read_to_tgt_rsp_pktid;  // Transaction pktid
+      sc_signal<data_t> * r_read_to_tgt_rsp_data;   // data (one cache line)
+      sc_signal<size_t>   r_read_to_tgt_rsp_word;   // first word of the response
+      sc_signal<size_t>   r_read_to_tgt_rsp_length; // length of the response
 
       ///////////////////////////////////////////////////////////////
@@ -473,57 +481,57 @@
       ///////////////////////////////////////////////////////////////
 
-      sc_signal<int>       r_write_fsm;             // FSM state
-      sc_signal<addr_t>	   r_write_address;         // first word address
-      sc_signal<size_t>    r_write_word_index;      // first word index in line
-      sc_signal<size_t>    r_write_word_count;      // number of words in line
-      sc_signal<size_t>    r_write_srcid;           // transaction srcid
-      sc_signal<size_t>    r_write_trdid;           // transaction trdid
-      sc_signal<size_t>    r_write_pktid;           // transaction pktid
-      sc_signal<data_t>	  *r_write_data;            // data (one cache line)	
-      sc_signal<be_t>     *r_write_be;              // one byte enable per word
-      sc_signal<bool>      r_write_byte;            // (BE != 0X0) and (BE != 0xF)
-      sc_signal<bool>      r_write_is_cnt;          // is_cnt bit (in directory)
-      sc_signal<bool>      r_write_lock;            // lock bit (in directory)
-      sc_signal<tag_t>     r_write_tag;             // cache line tag (in directory)
-      sc_signal<size_t>    r_write_copy;            // first owner of the line
-      sc_signal<size_t>    r_write_copy_cache;      // first owner of the line
-      sc_signal<bool>      r_write_copy_inst;       // is this owner a ICache ?
-      sc_signal<size_t>	   r_write_count;           // number of copies
-      sc_signal<size_t>    r_write_ptr;             // pointer to the heap
-      sc_signal<size_t>    r_write_next_ptr;        // next pointer to the heap
-      sc_signal<bool>      r_write_to_dec;          // need to decrement update counter
-      sc_signal<size_t>	   r_write_way;		        // way of the line
-      sc_signal<size_t>    r_write_trt_index;	    // index in Transaction Table
-      sc_signal<size_t>    r_write_upt_index;	    // index in Update Table
+      sc_signal<int>      r_write_fsm;        // FSM state
+      sc_signal<addr_t>   r_write_address;    // first word address
+      sc_signal<size_t>   r_write_word_index; // first word index in line
+      sc_signal<size_t>   r_write_word_count; // number of words in line
+      sc_signal<size_t>   r_write_srcid;      // transaction srcid
+      sc_signal<size_t>   r_write_trdid;      // transaction trdid
+      sc_signal<size_t>   r_write_pktid;      // transaction pktid
+      sc_signal<data_t> * r_write_data;       // data (one cache line)
+      sc_signal<be_t>   * r_write_be;         // one byte enable per word
+      sc_signal<bool>     r_write_byte;       // (BE != 0X0) and (BE != 0xF)
+      sc_signal<bool>     r_write_is_cnt;     // is_cnt bit (in directory)
+      sc_signal<bool>     r_write_lock;       // lock bit (in directory)
+      sc_signal<tag_t>    r_write_tag;        // cache line tag (in directory)
+      sc_signal<size_t>   r_write_copy;       // first owner of the line
+      sc_signal<size_t>   r_write_copy_cache; // first owner of the line
+      sc_signal<bool>     r_write_copy_inst;  // is this owner a ICache ?
+      sc_signal<size_t>   r_write_count;      // number of copies
+      sc_signal<size_t>   r_write_ptr;        // pointer to the heap
+      sc_signal<size_t>   r_write_next_ptr;   // next pointer to the heap
+      sc_signal<bool>     r_write_to_dec;     // need to decrement update counter
+      sc_signal<size_t>   r_write_way;        // way of the line
+      sc_signal<size_t>   r_write_trt_index;  // index in Transaction Table
+      sc_signal<size_t>   r_write_upt_index;  // index in Update Table
 
       // Buffer between WRITE fsm and TGT_RSP fsm (acknowledge a write command from L1)
-      sc_signal<bool>      r_write_to_tgt_rsp_req;		// valid request
-      sc_signal<size_t>    r_write_to_tgt_rsp_srcid;    // transaction srcid
-      sc_signal<size_t>    r_write_to_tgt_rsp_trdid;	// transaction trdid
-      sc_signal<size_t>    r_write_to_tgt_rsp_pktid;	// transaction pktid
-
-      // Buffer between WRITE fsm and IXR_CMD fsm (ask a missing cache line to XRAM) 
-      sc_signal<bool>	   r_write_to_ixr_cmd_req;      // valid request
-      sc_signal<bool>	   r_write_to_ixr_cmd_write;    // write request
-      sc_signal<addr_t>    r_write_to_ixr_cmd_nline; 	// cache line index
-      sc_signal<data_t>	  *r_write_to_ixr_cmd_data;	    // cache line data
-      sc_signal<size_t>    r_write_to_ixr_cmd_trdid;	// index in Transaction Table
+      sc_signal<bool>     r_write_to_tgt_rsp_req;   // valid request
+      sc_signal<size_t>   r_write_to_tgt_rsp_srcid; // transaction srcid
+      sc_signal<size_t>   r_write_to_tgt_rsp_trdid; // transaction trdid
+      sc_signal<size_t>   r_write_to_tgt_rsp_pktid; // transaction pktid
+
+      // Buffer between WRITE fsm and IXR_CMD fsm (ask a missing cache line to XRAM)
+      sc_signal<bool>     r_write_to_ixr_cmd_req;   // valid request
+      sc_signal<bool>     r_write_to_ixr_cmd_write; // write request
+      sc_signal<addr_t>   r_write_to_ixr_cmd_nline; // cache line index
+      sc_signal<data_t> * r_write_to_ixr_cmd_data;  // cache line data
+      sc_signal<size_t>   r_write_to_ixr_cmd_trdid; // index in Transaction Table
 
       // Buffer between WRITE fsm and INIT_CMD fsm (Update/Invalidate L1 caches)
-      sc_signal<bool>	   r_write_to_init_cmd_multi_req;   // valid multicast request
-      sc_signal<bool>	   r_write_to_init_cmd_brdcast_req; // valid brdcast request
-      sc_signal<addr_t>	   r_write_to_init_cmd_nline;	    // cache line index
-      sc_signal<size_t>	   r_write_to_init_cmd_trdid;	    // index in Update Table
-      sc_signal<data_t>   *r_write_to_init_cmd_data;	    // data (one cache line)
-      sc_signal<be_t>     *r_write_to_init_cmd_be;	        // word enable
-      sc_signal<size_t>	   r_write_to_init_cmd_count;	    // number of words in line
-      sc_signal<size_t>	   r_write_to_init_cmd_index;	    // index of first word in line
-      GenericFifo<bool>    m_write_to_init_cmd_inst_fifo;   // fifo for the L1 type
-      GenericFifo<size_t>  m_write_to_init_cmd_srcid_fifo;  // fifo for srcids
-      GenericFifo<size_t>  m_write_to_init_cmd_cache_id_fifo;  // fifo for srcids
+      sc_signal<bool>     r_write_to_init_cmd_multi_req;     // valid multicast request
+      sc_signal<bool>     r_write_to_init_cmd_brdcast_req;   // valid brdcast request
+      sc_signal<addr_t>   r_write_to_init_cmd_nline;         // cache line index
+      sc_signal<size_t>   r_write_to_init_cmd_trdid;         // index in Update Table
+      sc_signal<data_t> * r_write_to_init_cmd_data;          // data (one cache line)
+      sc_signal<be_t>   * r_write_to_init_cmd_be;            // word enable
+      sc_signal<size_t>   r_write_to_init_cmd_count;         // number of words in line
+      sc_signal<size_t>   r_write_to_init_cmd_index;         // index of first word in line
+      GenericFifo<bool>   m_write_to_init_cmd_inst_fifo;     // fifo for the L1 type
+      GenericFifo<size_t> m_write_to_init_cmd_srcid_fifo;    // fifo for srcids
+      GenericFifo<size_t> m_write_to_init_cmd_cache_id_fifo; // fifo for srcids
 
       // Buffer between WRITE fsm and INIT_RSP fsm (Decrement UPT entry)
-      sc_signal<bool>      r_write_to_init_rsp_req;         // valid request
-      sc_signal<size_t>    r_write_to_init_rsp_upt_index;   // index in update table
+      sc_signal<bool>     r_write_to_init_rsp_req;       // valid request
+      sc_signal<size_t>   r_write_to_init_rsp_upt_index; // index in update table
 
       /////////////////////////////////////////////////////////
@@ -531,16 +539,16 @@
       //////////////////////////////////////////////////////////
 
-      sc_signal<int> 	   r_init_rsp_fsm;        // FSM state
-      sc_signal<size_t>	   r_init_rsp_upt_index;  // index in the Update Table
-      sc_signal<size_t>	   r_init_rsp_srcid;	  // pending write srcid      
-      sc_signal<size_t>	   r_init_rsp_trdid;	  // pending write trdid      
-      sc_signal<size_t>	   r_init_rsp_pktid;	  // pending write pktid      
-      sc_signal<addr_t>	   r_init_rsp_nline;	  // pending write nline      
+      sc_signal<int>      r_init_rsp_fsm;       // FSM state
+      sc_signal<size_t>   r_init_rsp_upt_index; // index in the Update Table
+      sc_signal<size_t>   r_init_rsp_srcid;     // pending write srcid
+      sc_signal<size_t>   r_init_rsp_trdid;     // pending write trdid
+      sc_signal<size_t>   r_init_rsp_pktid;     // pending write pktid
+      sc_signal<addr_t>   r_init_rsp_nline;     // pending write nline
 
       // Buffer between INIT_RSP fsm and TGT_RSP fsm (complete write/update transaction)
-      sc_signal<bool>	   r_init_rsp_to_tgt_rsp_req;   	// valid request
-      sc_signal<size_t>	   r_init_rsp_to_tgt_rsp_srcid;		// Transaction srcid
-      sc_signal<size_t>	   r_init_rsp_to_tgt_rsp_trdid;		// Transaction trdid
-      sc_signal<size_t>	   r_init_rsp_to_tgt_rsp_pktid;		// Transaction pktid
+      sc_signal<bool>     r_init_rsp_to_tgt_rsp_req;   // valid request
+      sc_signal<size_t>   r_init_rsp_to_tgt_rsp_srcid; // Transaction srcid
+      sc_signal<size_t>   r_init_rsp_to_tgt_rsp_trdid; // Transaction trdid
+      sc_signal<size_t>   r_init_rsp_to_tgt_rsp_pktid; // Transaction pktid
 
       ///////////////////////////////////////////////////////
@@ -548,38 +556,38 @@
       ///////////////////////////////////////////////////////
 
-      sc_signal<int> 	     r_cleanup_fsm;         // FSM state
-      sc_signal<size_t>      r_cleanup_srcid;       // transaction srcid
-      sc_signal<size_t>      r_cleanup_trdid;       // transaction trdid
-      sc_signal<size_t>      r_cleanup_pktid;       // transaction pktid
-      sc_signal<addr_t>      r_cleanup_nline;       // cache line index
-
-      sc_signal<copy_t>      r_cleanup_copy;        // first copy
-      sc_signal<copy_t>      r_cleanup_copy_cache;  // first copy
-      sc_signal<size_t>      r_cleanup_copy_inst;   // type of the first copy
-      sc_signal<copy_t>      r_cleanup_count;       // number of copies 
-      sc_signal<size_t>      r_cleanup_ptr;         // pointer to the heap
-      sc_signal<size_t>      r_cleanup_prev_ptr;    // previous pointer to the heap
-      sc_signal<size_t>      r_cleanup_prev_srcid;  // srcid of previous heap entry
-      sc_signal<size_t>      r_cleanup_prev_cache_id;  // srcid of previous heap entry
-      sc_signal<bool>        r_cleanup_prev_inst;   // inst bit of previous heap entry
-      sc_signal<size_t>      r_cleanup_next_ptr;    // next pointer to the heap
-      sc_signal<tag_t>       r_cleanup_tag;	        // cache line tag (in directory)
-      sc_signal<bool>        r_cleanup_is_cnt;      // inst bit (in directory)
-      sc_signal<bool>        r_cleanup_lock;	    // lock bit (in directory)
-      sc_signal<bool>        r_cleanup_dirty;	    // dirty bit (in directory)
-      sc_signal<size_t>      r_cleanup_way;	        // associative way (in cache)
-
-      sc_signal<size_t>      r_cleanup_write_srcid; // srcid of write response
-      sc_signal<size_t>      r_cleanup_write_trdid; // trdid of write rsp
-      sc_signal<size_t>      r_cleanup_write_pktid; // pktid of write rsp
-      sc_signal<bool>        r_cleanup_need_rsp;    // needs a write rsp
-
-      sc_signal<size_t>      r_cleanup_index;	    // index of the INVAL line (in the UPT)
+      sc_signal<int>      r_cleanup_fsm;           // FSM state
+      sc_signal<size_t>   r_cleanup_srcid;         // transaction srcid
+      sc_signal<size_t>   r_cleanup_trdid;         // transaction trdid
+      sc_signal<size_t>   r_cleanup_pktid;         // transaction pktid
+      sc_signal<addr_t>   r_cleanup_nline;         // cache line index
+
+      sc_signal<copy_t>   r_cleanup_copy;          // first copy
+      sc_signal<copy_t>   r_cleanup_copy_cache;    // first copy
+      sc_signal<size_t>   r_cleanup_copy_inst;     // type of the first copy
+      sc_signal<copy_t>   r_cleanup_count;         // number of copies
+      sc_signal<size_t>   r_cleanup_ptr;           // pointer to the heap
+      sc_signal<size_t>   r_cleanup_prev_ptr;      // previous pointer to the heap
+      sc_signal<size_t>   r_cleanup_prev_srcid;    // srcid of previous heap entry
+      sc_signal<size_t>   r_cleanup_prev_cache_id; // srcid of previous heap entry
+      sc_signal<bool>     r_cleanup_prev_inst;     // inst bit of previous heap entry
+      sc_signal<size_t>   r_cleanup_next_ptr;      // next pointer to the heap
+      sc_signal<tag_t>    r_cleanup_tag;           // cache line tag (in directory)
+      sc_signal<bool>     r_cleanup_is_cnt;        // inst bit (in directory)
+      sc_signal<bool>     r_cleanup_lock;          // lock bit (in directory)
+      sc_signal<bool>     r_cleanup_dirty;         // dirty bit (in directory)
+      sc_signal<size_t>   r_cleanup_way;           // associative way (in cache)
+
+      sc_signal<size_t>   r_cleanup_write_srcid;   // srcid of write response
+      sc_signal<size_t>   r_cleanup_write_trdid;   // trdid of write rsp
+      sc_signal<size_t>   r_cleanup_write_pktid;   // pktid of write rsp
+      sc_signal<bool>     r_cleanup_need_rsp;      // needs a write rsp
+
+      sc_signal<size_t>   r_cleanup_index;         // index of the INVAL line (in the UPT)
 
       // Buffer between CLEANUP fsm and TGT_RSP fsm (acknowledge a write command from L1)
-      sc_signal<bool>      r_cleanup_to_tgt_rsp_req;    // valid request
-      sc_signal<size_t>    r_cleanup_to_tgt_rsp_srcid;  // transaction srcid
-      sc_signal<size_t>    r_cleanup_to_tgt_rsp_trdid;	// transaction trdid
-      sc_signal<size_t>    r_cleanup_to_tgt_rsp_pktid;	// transaction pktid
+      sc_signal<bool>     r_cleanup_to_tgt_rsp_req;   // valid request
+      sc_signal<size_t>   r_cleanup_to_tgt_rsp_srcid; // transaction srcid
+      sc_signal<size_t>   r_cleanup_to_tgt_rsp_trdid; // transaction trdid
+      sc_signal<size_t>   r_cleanup_to_tgt_rsp_pktid; // transaction pktid
 
       ///////////////////////////////////////////////////////
